/**
 * Copyright 2007-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.api;

/**
 * Metadata that needs to use #64;{@link org.ow2.util.pool.annotation.Pool} annotation needs to implement this interface.
 * @author Florent BENOIT
 */
public interface IPoolMetadata {

    /**
     * @return the pool configuration for this metadata.
     */
    IPoolConfiguration getPoolConfiguration();

    /**
     * Sets the pool configuration for this metadata.
     * @param poolConfiguration the given configuration.
     */
    void setPoolConfiguration(IPoolConfiguration poolConfiguration);

}
