/**
 * Copyright 2007-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.api;



/**
 * State for a given pool.
 * @author Florent Benoit
 */
public interface IPoolState {

    int getCreatingItemCount();

    int getAvailableItemCount();

    int getBusyItemCount();

    int getRemovingItemCount();

    FactoryState getFactoryState();

    int getExpectedItemCount();

    void setCreatingItemCount(final int creatingItemCount);

    void setAvailableItemCount(final int availableItemCount);

    void setBusyItemCount(final int busyItemCount);

    void setRemovingItemCount(final int removingItemCount);

    void setFactoryState(final FactoryState factoryState);

    void setExpectedItemCount(final int expectedItemCount);

}
