/**
 * Copyright 2007-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.pool.api;

/**
 * Defines the interface used to collect/set information on this pool.
 * @author Florent Benoit
 */
public interface PoolAttributes {
//
//    /**
//     * <b>getMaxAge</b> gets the max age for a pool entry.
//     * @return int max number of minutes to keep a connection in the pool.
//     */
//    int getMaxAge();
//
//    /**
//     * <b>getMaxOpentime</b> gets the max age for a pool entry.
//     * @return int max number of minutes to keep a connection in the pool.
//     */
//    int getMaxOpentime();
//
//    /**
//     * <b>getMaxSize</b> retrieves the maximum size assigned to this Pool.
//     * @return The maximum size currently assigned to this Pool.
//     */
//    int getMaxSize();
//
//    /**
//     * <b>getMaxWaiters</b> gets the maximum number of waiters for a connection
//     * in this Pool.
//     * @return int maximum number of waiters
//     */
//    int getMaxWaiters();
//
//    /**
//     * <b>getMaxWaitTime</b> gets the maximum number of seconds to wait for a
//     * connection in this Pool.
//     * @return int maximum number of seconds to wait
//     */
//    int getMaxWaitTime();
//
//    /**
//     * <b>getMinSize</b> retrieves the minimum size assigned to this Pool.
//     * @return The minimum size currently assigned to this Pool.
//     */
//    int getMinSize();
//
//    /**
//     * <b>getSamplingPeriod</b> gets the number of seconds between statistics
//     * sampling for this Pool.
//     * @return int number of seconds between samplings
//     */
//    int getSamplingPeriod();
//
//    /**
//     * <b>getTimeout</b> retrieves the timeout assigned to this Pool.
//     * @return The timeout currently assigned to this Pool.
//     */
//    long getTimeout();
//
//    /**
//     * <b>getSize</b> retrieves the current size of this Pool.
//     * @return The current size of this Pool.
//     */
//    int getSize();
//
//    /**
//     * @return init The pool init size.
//     */
//    int getInitSize();
//
//    /**
//     * <b>setInitSize</b> creates initsize resoures to this Pool.
//     * @param initsize The init size to be created.
//     * @throws Exception if an error occurs
//     */
//    void setInitSize(int initsize) throws Exception;
//
//    /**
//     * <b>setMaxAge</b> sets the max age for a pool entry.
//     * @param maxAge int max number of minutes to keep a connection in the pool.
//     */
//    void setMaxAge(int maxAge);
//
//    /**
//     * <b>setMaxOpentime</b> sets the max age for an entry to be opened.
//     * @param maxOpentime int max number of minutes to keep a connection opened.
//     */
//    void setMaxOpentime(int maxOpentime);
//
//    /**
//     * <b>setMaxSize</b> assigns a maximum size to this Pool.
//     * @param maxsize int maximum size to be assigned.
//     * @throws Exception if an error occurs
//     */
//    void setMaxSize(int maxsize) throws Exception;
//
//    /**
//     * <b>setMaxWaiters</b> sets the maximum number of waiters for a connection
//     * in this Pool.
//     * @param maxWaiters int maximum number of waiters
//     */
//    void setMaxWaiters(int maxWaiters);
//
//    /**
//     * <b>setMaxWaitTime</b> sets the maximum number of seconds to wait for a
//     * connection in this Pool.
//     * @param maxWaitTime int maximum number of seconds to wait
//     */
//    void setMaxWaitTime(int maxWaitTime);
//
//    /**
//     * <b>setMinSize</b> assigns a minimum size to this Pool.
//     * @param minsize int minimum size to be assigned.
//     * @throws Exception if an error occurs
//     */
//    void setMinSize(int minsize) throws Exception;
//
//    /**
//     * <b>setSamplingPeriod</b> sets the number of seconds between statistics
//     * sampling for this Pool.
//     * @param samplingPeriod int number of seconds between samplings
//     */
//    void setSamplingPeriod(int samplingPeriod);
//
//    /**
//     * <b>setTimeout</b> assigns a timeout to this Pool.
//     * @param crto long timeout to be assigned.
//     */
//    void setTimeout(long crto);
//
//
//    /**
//     * @return int number of busy connections
//     */
//    int getCurrentBusy();
//
//    /**
//     * @return int number of opened connections
//     */
//    int getCurrentOpened();
//
//    /**
//     * @return maximum nb of busy connections in last sampling period
//     */
//    int getBusyMaxRecent();
//
//    /**
//     * @return minimum nb of busy connections in last sampling period
//     */
//    int getBusyMinRecent();
//
//    /**
//     * @return current number of connection waiters
//     */
//    int getCurrentWaiters();
//
//    /**
//     * @return int number of physical jdbc connection opened
//     */
//    int getOpenedCount();
//
//    /**
//     * @return int number of connection failures on open
//     */
//    int getConnectionFailures();
//
//    /**
//     * @return int number of connection leaks
//     */
//    int getConnectionLeaks();
//
//    /**
//     * @return int number of connection served
//     */
//    int getServedOpen();
//
//    /**
//     * @return int number of open calls that were rejected due to waiter
//     *         overflow
//     */
//    int getRejectedFull();
//
//    /**
//     * @return int number of open calls that were rejected by timeout
//     */
//    int getRejectedTimeout();
//
//    /**
//     * @return int number of open calls that were rejected
//     */
//    int getRejectedOther();
//
//    /**
//     * @return int number of open calls that were rejected
//     */
//    int getRejectedOpen();
//
//    /**
//     * @return maximum nb of waiters since the datasource creation
//     */
//    int getWaitersHigh();
//
//    /**
//     * @return maximum nb of waiters in last sampling period
//     */
//    int getWaitersHighRecent();
//
//    /**
//     * @return total nb of waiters since the datasource creation
//     */
//    int getWaiterCount();
//
//    /**
//     * @return total waiting time since the datasource creation
//     */
//    long getWaitingTime();
//
//    /**
//     * @return max waiting time since the datasource creation
//     */
//    long getWaitingHigh();
//
//    /**
//     * @return max waiting time in last sampling period
//     */
//    long getWaitingHighRecent();
//
}
